/**********************************************************************************************/
/* MemPtr.h																					  */
/*                                                                       					  */
/* Copyright Paradigma, 1993-2002                                       					  */
/* All Rights Reserved.                                                 					  */
/**********************************************************************************************/

#ifndef __MemPtr_h 
	#define __MemPtr_h

#if defined(__MWERKS__)
	#pragma options align=power
#endif


/**********************************************************************************************/
template<class T> class MemPtr
{
	public://///////////////////////////////////////////////////////////////////////////////////

							MemPtr( ulong size ) { 
								mSize = size;
								p = size ? new T[size] : NULL; 
							}
							
							~MemPtr( void )
							{ 
								if(p) delete [] p; 
							}

							operator T* (void) 				{ return p; }
							operator const T* (void) const 	{ return p; }
					
		const T*			begin( void ) const 			{ return p; }
		const T*			end( void ) const 				{ return p + mSize; }
				
		T*					begin( void ) 					{ return p; }
		T*					end( void ) 	 				{ return p + mSize; }
				
		T&					operator[]( ulong inIndex ) 	{ return p[inIndex]; }		


	private:///////////////////////////////////////////////////////////////////////////////////

		T* 					p;
		ulong 				mSize;
};


/**********************************************************************************************/
#if defined(__MWERKS__)
	#pragma options align=reset
#endif

#endif // __MemPtr_h
